﻿using System;
using Styx;
using Styx.CommonBot.Routines;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;
using Action = Styx.TreeSharp.Action;

namespace katzerle.Composites
{
    public class FollowPathAction : Action
    {

        private readonly LocalPlayer _me = StyxWoW.Me;

        protected override RunStatus Run(object context)
        {
            if (FlyAroundBot.CurrentPoint == WoWPoint.Zero )
                return RunStatus.Failure;
            if ((FlyAroundBot.WayPoints.Count == 1) && (StyxWoW.Me.Location.Distance(FlyAroundBot.CurrentPoint) < 5))
            {
                return RunStatus.Failure;
            }

            float precision = StyxWoW.Me.IsFlying ? 15f : 3; 
            if (StyxWoW.Me.Location.Distance(FlyAroundBot.CurrentPoint) <= precision)
                FlyAroundBot.CycleToNextPoint();
            if (_me.IsSwimming)
            {
                if (_me.GetMirrorTimerInfo(MirrorTimerType.Breath).CurrentTime > 0)
                    WoWMovement.Move(WoWMovement.MovementDirection.JumpAscend);
                else if (_me.MovementInfo.IsAscending || _me.MovementInfo.JumpingOrShortFalling)
                    WoWMovement.MoveStop(WoWMovement.MovementDirection.JumpAscend);
            }
            if (!StyxWoW.Me.Mounted)
                Flightor.MountHelper.MountUp();
            Flightor.MoveTo(FlyAroundBot.CurrentPoint);
            return RunStatus.Success;
        }

 
    }
}